package com.fr.plugin.decision.integration.resource;

import com.fr.decision.fun.impl.AbstractWebResourceProvider;
import com.fr.decision.web.MainComponent;
import com.fr.plugin.decision.integration.config.IntegrateConf;
import com.fr.web.struct.Atom;
import com.fr.web.struct.Component;
import com.fr.web.struct.Filter;
import com.fr.web.struct.category.ScriptPath;

/**
 * @Author JianYe.Wang
 * @Data 2022/4/1 15:22
 * @Description TODO
 * @Version 10.0
 **/
public class WebStartWebResourceImpl extends AbstractWebResourceProvider {

    @Override
    public Atom attach() {
        return MainComponent.KEY;
    }

    @Override
    public Atom client() {
        return new Component() {
            @Override
            public ScriptPath script() {
                return ScriptPath.build("com/fr/plugin/decision/integration/web/js/web_start.js");
            }

            @Override
            public Filter filter() {
                return new Filter() {
                    @Override
                    public boolean accept() {
                        return IntegrateConf.getInstance().getWebStartDesigner();
                    }
                };
            }
        };
    }
}
