package com.fr.plugin.decision.integration.token;

import com.fr.plugin.context.PluginContexts;
import com.fr.stable.fun.impl.AbstractJavaScriptFileHandler;

/**
 * @Author JianYe.Wang
 * @Data 2022/7/21 11:12
 * @Description 兼容报表访问地址通过URL传递fine_auth_token的形式
 * @Version 10.0
 **/
public class LoadTokenJSFileHandler extends AbstractJavaScriptFileHandler {

    @Override
    public String[] pathsForFiles() {
        if (!PluginContexts.currentContext().isAvailable()) {
            return new String[0];
        }

        return new String[] {"com/fr/plugin/decision/integration/token/js/token.js"};
    }
}
