!(function () {
    var Item = BI.inherit(BI.Widget, {
        props: {
            value: "",
            items: [],
            changeAction: BI.emptyFn()
        },

        render: function () {
            var self = this, o = this.options;
            return {
                type: "bi.button_group",
                value: o.value + "",
                layouts: [{
                    type: "bi.vertical_adapt"
                }],
                items: BI.createItems(o.items, {
                    type: "bi.single_select_radio_item",
                    height: 16,
                    logic: {
                        dynamic: true
                    },
                    cls: "bi-list-item-none"
                }),
                listeners: [{
                    eventName: BI.ButtonGroup.EVENT_CHANGE,
                    action: function (e) {
                        o.changeAction && o.changeAction(e);
                    }
                }],
                ref: function (_ref) {
                    self.group = _ref;
                }
            }
        },

        getValue: function () {
            return this.group.getValue()[0];
        }
    });
    BI.shortcut("dec.plugin.system.integration.group", Item);
})();