package com.fr.plugin.decision.integration.validation;

import com.fr.stable.StringUtils;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;

/**
 * @Author JianYe.Wang
 * @Data 2022/6/16 9:34
 * @Description TODO
 * @Version 10.0
 **/
public class TemplateValidate implements Validate{

    public static final Validate KEY = new TemplateValidate();

    @Override
    public boolean accept(HttpServletRequest request) {
        return StringUtils.isNotEmpty(WebUtils.getReportTitleFromRequest(request));
    }

    @Override
    public HashMap<String, Object> getCheckParameter(HttpServletRequest request) {
        HashMap<String, Object> param = new HashMap<>();
        param.put("reportlet", WebUtils.getReportTitleFromRequest(request));
        return param;
    }
}
