!(function () {
    BI.config("dec.constant.header.items", function (items) {
        var customColors;
        switch (Dec.system.styleConfig.colorScheme) {
            case 0:
                customColors = BI.Constants.getConstant("dec.constant.look.color.scheme.light");
                break;
            case 1:
                customColors = BI.Constants.getConstant("dec.constant.look.color.scheme.dark");
                break;
            case 2:
                customColors = Dec.system.styleConfig.customColors;
                break;
        }
        var color = customColors[5], bgColor = customColors[1];
        return BI.concat([{
            type: "bi.button",
            text: "启动设计器",
            //ghost: true,
            css: {color: color, "background-color": bgColor, "border-color": bgColor},
            handler: function () {
                Dec.Utils.getWebStartInfo(function (res) {
                    if (res.data) {
                        console.log(res);
                        window.protocolCheck(res.data.url, function () {
                            var agent = navigator.userAgent.toLowerCase();
                            var is64 = agent.indexOf("win64") >= 0 || agent.indexOf("wow64") >= 0 || agent.indexOf("x64") >= 0;
                            var downloadURL = is64 ? res.data.download64 : res.data.download32;
                            console.log(downloadURL);
                            window.open(downloadURL);
                        })
                    } else {
                        BI.Msg.toast(res.errorMsg, {level: "error"})
                    }
                })
            }
        }], items);
    });
})();